Hardware Locality (hwloc): Converting between Object Types, Sets and Attributes, and Strings

Hardware Locality (hwloc) 1.11.13

Functions
Converting between Object Types, Sets and Attributes, and Strings

## Functions
const char * | hwloc_obj_type_string (hwloc_obj_type_t type)
int | hwloc_obj_type_snprintf (char *restrict string, size_t size, hwloc_obj_t obj, int verbose)
int | hwloc_obj_attr_snprintf (char *restrict string, size_t size, hwloc_obj_t obj, const char *restrict separator, int verbose)
int | hwloc_obj_cpuset_snprintf (char *restrict str, size_t size, size_t nobj, const hwloc_obj_t *restrict objs)
int | hwloc_obj_type_sscanf (const char *string, hwloc_obj_type_t *typep, int *depthattrp, void *typeattrp, size_t typeattrsize)

## Detailed Description

## Function Documentation

## ◆ hwloc_obj_attr_snprintf()

int hwloc_obj_attr_snprintf | ( | char *restrict | string,
|  | size_t | size,
|  | hwloc_obj_t | obj,
|  | const char *restrict | separator,
|  | int | verbose
| ) |  |

Stringify the attributes of a given topology object into a human-readable form.

Attribute values are separated by `separator`.

Only the major attributes are printed in non-verbose mode.

If `size` is 0, `string` may safely be `NULL`.

Returns
  the number of character that were actually written if not truncating, or that would have been written (not including the ending \0).

## ◆ hwloc_obj_cpuset_snprintf()

int hwloc_obj_cpuset_snprintf | ( | char *restrict | str,
|  | size_t | size,
|  | size_t | nobj,
|  | const hwloc_obj_t *restrict | objs
| ) |  |

Stringify the cpuset containing a set of objects.

If `size` is 0, `string` may safely be `NULL`.

Returns
  the number of character that were actually written if not truncating, or that would have been written (not including the ending \0).

## ◆ hwloc_obj_type_snprintf()

int hwloc_obj_type_snprintf | ( | char *restrict | string,
|  | size_t | size,
|  | hwloc_obj_t | obj,
|  | int | verbose
| ) |  |

Stringify the type of a given topology object into a human-readable form.

Contrary to hwloc_obj_type_string(), this function includes object-specific attributes (such as the Group depth, the Bridge type, or OS device type) in the output, and it requires the caller to provide the output buffer.

The output is guaranteed to be the same for all objects of a same topology level.

If `size` is 0, `string` may safely be `NULL`.

Returns
  the number of character that were actually written if not truncating, or that would have been written (not including the ending \0).

## ◆ hwloc_obj_type_sscanf()

int hwloc_obj_type_sscanf | ( | const char * | string,
|  | hwloc_obj_type_t * | typep,
|  | int * | depthattrp,
|  | void * | typeattrp,
|  | size_t | typeattrsize
| ) |  |

Return an object type and attributes from a type string.

Convert strings such as "Package" or "Cache" into the corresponding types. Matching is case-insensitive, and only the first letters are actually required to match.

This function is guaranteed to match any string returned by hwloc_obj_type_string() or hwloc_obj_type_snprintf().

Types that have specific attributes, for instance caches and groups, may be returned in `depthattrp` and `typeattrp`. They are ignored when these pointers are `NULL`.

For instance "L2i" or "L2iCache" would return type HWLOC_OBJ_CACHE in `typep`, 2 in `depthattrp`, and HWLOC_OBJ_CACHE_TYPE_INSTRUCTION in `typeattrp` (this last pointer should point to a hwloc_obj_cache_type_t). "Group3" would return type HWLOC_OBJ_GROUP type and 3 in `depthattrp`. Attributes that are not specified in the string (for instance "Group" without a depth, or "L2Cache" without a cache type) are set to -1.

`typeattrp` is only filled if the size specified in `typeattrsize` is large enough. It is currently only used for caches, and the required size is at least the size of hwloc_obj_cache_type_t.

Returns
  0 if a type was correctly identified, otherwise -1.

Note
  This is an extended version of the now deprecated hwloc_obj_type_of_string()

## ◆ hwloc_obj_type_string()

const char* hwloc_obj_type_string | ( | hwloc_obj_type_t | type | ) |

Return a constant stringified object type.

This function is the basic way to convert a generic type into a string.

hwloc_obj_type_snprintf() may return a more precise output for a specific object, but it requires the caller to provide the output buffer.